﻿using Prism.Mvvm;
using Prism.Regions;

namespace TestLibrary.ViewModels
{
    /// <summary>
    /// 뷰 B 뷰 모델
    /// </summary>
    public class ViewBViewModel : BindableBase, INavigationAware
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 제목
        /// </summary>
        private string title = "View B";

        /// <summary>
        /// 페이지 뷰 카운트
        /// </summary>
        private int pageViewCount;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 제목 - Title

        /// <summary>
        /// 제목
        /// </summary>
        public string Title
        {
            get
            {
                return this.title;
            }
            set
            {
                SetProperty(ref this.title, value);
            }
        }

        #endregion
        #region 페이지 뷰 카운트 - PageViewCount

        /// <summary>
        /// 페이지 뷰 카운트
        /// </summary>
        public int PageViewCount
        {
            get
            {
                return this.pageViewCount;
            }
            set
            {
                SetProperty(ref this.pageViewCount, value);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ViewBViewModel()

        /// <summary>
        /// 생성자
        /// </summary>
        public ViewBViewModel()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 탐색 타겟 여부 구하기 - IsNavigationTarget(navigationContext)

        /// <summary>
        /// 탐색 타겟 여부 구하기
        /// </summary>
        /// <param name="navigationContext">탐색 컨텍스트</param>
        /// <returns>탐색 타겟 여부</returns>
        public bool IsNavigationTarget(NavigationContext navigationContext)
        {
            return true;
        }

        #endregion
        #region 탐색 진입시 처리하기 - OnNavigatedTo(navigationContext)

        /// <summary>
        /// 탐색 진입시 처리하기
        /// </summary>
        /// <param name="navigationContext">탐색 컨텍스트</param>
        public void OnNavigatedTo(NavigationContext navigationContext)
        {
            PageViewCount++;
        }

        #endregion
        #region 탐색 이탈시 처리하기 - OnNavigatedFrom(navigationContext)

        /// <summary>
        /// 탐색 이탈시 처리하기
        /// </summary>
        /// <param name="navigationContext">탐색 컨텍스트</param>
        public void OnNavigatedFrom(NavigationContext navigationContext)
        {
        }

        #endregion
    }
}